net.sf.saxon.expr

## Class Expression

- java.lang.Object
- - net.sf.saxon.expr.Expression

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, InstructionInfo, Locator
  Direct Known Subclasses:
    Assignation, AxisExpression, BasicUpdatingExpression, BinaryExpression, CompareToIntegerConstant, CompiledExpression, ConditionalSorter, ContextItemExpression, CopyModifyExpression, ErrorExpression, EvaluateInstr, FilterExpression, FLWORExpression, FunctionCall, IndexedFilterExpression, IndexedLookupExpression, Instruction, IntegerRangeTest, IsLastExpression, Literal, NumberInstruction, PartialApply, PatternSponsor, SimpleExpression, SingleNodeExpression, SlashExpression, SortExpression, StreamingCopy, SuppliedParameterReference, SwitchExpression, TailExpression, TryCatch, TupleExpression, UnaryExpression, VariableReference

      public abstract class Expression
      extends Object
      implements Serializable, SourceLocator, InstructionInfo

  Interface supported by an XPath expression. This includes both compile-time and run-time methods.

  Two expressions are considered equal if they return the same result when evaluated in the same context.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `EFFECTIVE_BOOLEAN_VALUE`
    `static int` | `EVALUATE_METHOD`
    `static int` | `EVENT_FEED_METHOD`
    `static int` | `INHERITED_CONTEXT`
    `static int` | `INSPECTION_CONTEXT`
    `static int` | `ITEM_FEED_METHOD`
    `static int` | `ITERATE_METHOD`
    `protected int` | `locationId`
    `static IntegerValue` | `MAX_SEQUENCE_LENGTH`
    `static IntegerValue` | `MAX_STRING_LENGTH`
    `static int` | `NAVIGATION_CONTEXT`
    `static int` | `NODE_VALUE_CONTEXT`
    `static int` | `PROCESS_METHOD`
    `static int` | `PUSH_SELECTION`
    `protected int` | `staticProperties`
    `static IntegerValue` | `UNBOUNDED_LOWER`
    `static IntegerValue` | `UNBOUNDED_UPPER`
    `static int` | `W3C_CONSUMING`
    `static int` | `W3C_FREE_RANGING`
    `static int` | `W3C_GROUP_CONSUMING`
    `static int` | `W3C_MOTIONLESS`
    `static int` | `WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Expression()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
    `void` | `adoptChildExpression(Expression child)` Set up a parent-child relationship between this expression and a given child expression.
    `void` | `checkForUpdatingSubexpressions()` Check to ensure that this expression does not contain any inappropriate updating subexpressions.
    `void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `protected abstract int` | `computeCardinality()` Compute the static cardinality of this expression
    `int` | `computeDependencies()` Compute the dependencies of an expression, as the union of the dependencies of its subexpressions.
    `protected int` | `computeSpecialProperties()` Compute the special properties of this expression.
    `void` | `computeStaticProperties()` Compute the static properties.
    `abstract Expression` | `copy()` Copy an expression.
    `Expression` | `doPromotion(Expression subexpression, PromotionOffer offer)` Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree
    `protected void` | `dynamicError(String message, String code, XPathContext context)` Method used in subclasses to signal a dynamic error
    `boolean` | `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the expression.
    `CharSequence` | `evaluateAsString(XPathContext context)` Evaluate an expression as a String.
    `Item` | `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
    `void` | `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
    `abstract void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `void` | `explain(OutputStream out)` Diagnostic print of expression structure.
    `int` | `getCardinality()` Determine the static cardinality of the expression.
    `int` | `getColumnNumber()` Get the column number of the expression
    `int` | `getColumnNumber(long locationId)` Get the column number within the document, entity, or module containing a particular location
    `int` | `getConstructType()` Get the type of this expression for use in tracing and diagnostics
    `Container` | `getContainer()` Get the container in which this expression is located.
    `int` | `getDependencies()` Determine which aspects of the context the expression depends on.
    `int` | `getEvaluationMethod()`
    `Executable` | `getExecutable()` Get the executable containing this expression
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler relating to a particular expression
    `String` | `getExpressionName()` Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getHostLanguage()` Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
    `int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `IntegerValue[]` | `getIntegerBounds()` For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
    `int` | `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
    `abstract ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the expression, if possible.
    `int` | `getLineNumber()` Get the line number of the expression
    `int` | `getLineNumber(long locationId)` Get the line number within the document or module containing a particular location
    `int` | `getLocationId()` Get the location ID of the expression
    `LocationProvider` | `getLocationProvider()` Get the LocationProvider allowing location identifiers to be resolved.
    `StructuredQName` | `getObjectName()` Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `Iterator<String>` | `getProperties()` Get an iterator over all the properties available.
    `Object` | `getProperty(String name)` Get the value of a particular property of the instruction.
    `String` | `getPublicId()` Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)
    `int[]` | `getSlotsUsed()` Get the local variables (identified by their slot numbers) on which this expression depends.
    `int` | `getSpecialProperties()` Get the static properties of this expression (other than its type).
    `int` | `getStreamability(int syntacticContext, boolean allowExtensions, List<String> reasons)` Get the "sweep" of this expression as defined in the W3C streamability specifications.
    `StreamingAdjunct` | `getStreamingAdjunct()` Get a class that supports streamed evaluation of this expression
    `String` | `getSystemId()` Get the systemId of the module containing the expression
    `String` | `getSystemId(long locationId)` Get the URI of the document or module containing a particular location
    `boolean` | `hasVariableBinding(Binding binding)`
    `boolean` | `implementsStaticTypeCheck()` Determine whether this expression implements its own method for static type checking
    `boolean` | `isSubtreeExpression()` Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
    `boolean` | `isUpdatingExpression()` Determine whether this is an updating expression as defined in the XQuery update specification
    `boolean` | `isVacuousExpression()` Determine whether this is a vacuous expression as defined in the XQuery update specification
    `SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
    `EventIterator` | `iterateEvents(XPathContext context)` Deliver the result of the expression as a sequence of events.
    `Iterator<SubExpressionInfo>` | `iterateSubExpressionInfo()` Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
    `int` | `markTailFunctionCalls(StructuredQName qName, int arity)` Mark tail-recursive calls on stylesheet functions.
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `process(XPathContext context)` Process the instruction, without returning any tail calls
    `Expression` | `promote(PromotionOffer offer, Expression parent)` Offer promotion for this subexpression.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `resetLocalStaticProperties()` Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.
    `void` | `setContainer(Container container)` Mark an expression as being in a given Container.
    `void` | `setEvaluationMethod(int method)`
    `void` | `setFiltered(boolean filtered)` Mark an expression as filtered: that is, it appears as the base expression in a filter expression.
    `void` | `setFlattened(boolean flattened)` Mark an expression as being "flattened".
    `void` | `setLocationId(int id)` Set the location ID on an expression.
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
    `Expression` | `staticTypeCheck(SequenceType req, boolean backwardsCompatible, RoleLocator role, TypeCheckerEnvironment visitor)` Static type checking of some expressions is delegated to the expression itself, by calling this method.
    `void` | `suppressValidation(int parentValidationMode)` Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation.
    `Pattern` | `toPattern(Configuration config, boolean is30)` Convert this expression to an equivalent XSLT pattern
    `Pattern` | `toStreamingPattern(Configuration config, List<String> reasonForFailure)` Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
    `String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.
    `protected void` | `typeError(String message, String errorCode, XPathContext context)` Method used in subclasses to signal a runtime type error

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### EVALUATE_METHOD

          public static final int EVALUATE_METHOD

      See Also:
        Constant Field Values

    - #### ITERATE_METHOD

          public static final int ITERATE_METHOD

      See Also:
        Constant Field Values

    - #### PROCESS_METHOD

          public static final int PROCESS_METHOD

      See Also:
        Constant Field Values

    - #### WATCH_METHOD

          public static final int WATCH_METHOD

      See Also:
        Constant Field Values

    - #### ITEM_FEED_METHOD

          public static final int ITEM_FEED_METHOD

      See Also:
        Constant Field Values

    - #### EVENT_FEED_METHOD

          public static final int EVENT_FEED_METHOD

      See Also:
        Constant Field Values

    - #### PUSH_SELECTION

          public static final int PUSH_SELECTION

      See Also:
        Constant Field Values

    - #### EFFECTIVE_BOOLEAN_VALUE

          public static final int EFFECTIVE_BOOLEAN_VALUE

      See Also:
        Constant Field Values

    - #### W3C_MOTIONLESS

          public static final int W3C_MOTIONLESS

      See Also:
        Constant Field Values

    - #### W3C_GROUP_CONSUMING

          public static final int W3C_GROUP_CONSUMING

      See Also:
        Constant Field Values

    - #### W3C_CONSUMING

          public static final int W3C_CONSUMING

      See Also:
        Constant Field Values

    - #### W3C_FREE_RANGING

          public static final int W3C_FREE_RANGING

      See Also:
        Constant Field Values

    - #### NAVIGATION_CONTEXT

          public static final int NAVIGATION_CONTEXT

      See Also:
        Constant Field Values

    - #### NODE_VALUE_CONTEXT

          public static final int NODE_VALUE_CONTEXT

      See Also:
        Constant Field Values

    - #### INHERITED_CONTEXT

          public static final int INHERITED_CONTEXT

      See Also:
        Constant Field Values

    - #### INSPECTION_CONTEXT

          public static final int INSPECTION_CONTEXT

      See Also:
        Constant Field Values

    - #### staticProperties

          protected int staticProperties

    - #### locationId

          protected int locationId

    - #### UNBOUNDED_LOWER

          public static final IntegerValue UNBOUNDED_LOWER

    - #### UNBOUNDED_UPPER

          public static final IntegerValue UNBOUNDED_UPPER

    - #### MAX_STRING_LENGTH

          public static final IntegerValue MAX_STRING_LENGTH

    - #### MAX_SEQUENCE_LENGTH

          public static final IntegerValue MAX_SEQUENCE_LENGTH

  - ### Constructor Detail

    - #### Expression

          public Expression()

  - ### Method Detail

    - #### getExpressionName

          public String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in explain() output displaying the expression.

    - #### getImplementationMethod

          public int getImplementationMethod()

      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.
      Returns:
        the implementation method, for example `ITERATE_METHOD` or `EVALUATE_METHOD` or `PROCESS_METHOD`

    - #### implementsStaticTypeCheck

          public boolean implementsStaticTypeCheck()

      Determine whether this expression implements its own method for static type checking
      Returns:
        true if this expression has a non-trivial implementation of the staticTypeCheck() method

    - #### hasVariableBinding

          public boolean hasVariableBinding(Binding binding)

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### staticTypeCheck

          public Expression staticTypeCheck(SequenceType req,
                                   boolean backwardsCompatible,
                                   RoleLocator role,
                                   TypeCheckerEnvironment visitor)
                                     throws XPathException

      Static type checking of some expressions is delegated to the expression itself, by calling this method. The default implementation of the method throws UnsupportedOperationException. If there is a non-default implementation, then implementsStaticTypeCheck() will return true
      Parameters:
        `req` - the required type
        `backwardsCompatible` - true if backwards compatibility mode applies
        `role` - the role of the expression in relation to the required type
        `visitor` - an expression visitor
      Returns:
        the expression after type checking (perhaps augmented with dynamic type checking code)
      Throws:
        `XPathException` - if failures occur, for example if the static type of one branch of the conditional is incompatible with the required type

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### promote

          public Expression promote(PromotionOffer offer,
                           Expression parent)
                             throws XPathException

      Offer promotion for this subexpression. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

      This method must be overridden for any Expression that has subexpressions.

      Parameters:
        `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
        `parent` - the containing expression in the expression tree
      Returns:
        if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
      Throws:
        `XPathException` - if any error is detected

    - #### getSpecialProperties

          public final int getSpecialProperties()

      Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.
      Returns:
        a set of flags indicating static properties of this expression

    - #### getCardinality

          public int getCardinality()

      Determine the static cardinality of the expression. This establishes how many items there will be in the result of the expression, at compile time (i.e., without actually evaluating the result.
      Returns:
        one of the values Cardinality.ONE_OR_MORE, Cardinality.ZERO_OR_MORE, Cardinality.EXACTLY_ONE, Cardinality.ZERO_OR_ONE, Cardinality.EMPTY. This default implementation returns ZERO_OR_MORE (which effectively gives no information).

    - #### getItemType

          public abstract ItemType getItemType(TypeHierarchy th)

      Determine the data type of the expression, if possible. All expression return sequences, in general; this method determines the type of the items within the sequence, assuming that (a) this is known in advance, and (b) it is the same for all items in the sequence.

      This method should always return a result, though it may be the best approximation that is available at the time.

      Parameters:
        `th` - the type hierarchy cache
      Returns:
        a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known at compile time)

    - #### getDependencies

          public int getDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.
      Returns:
        a set of bit-significant flags identifying the dependencies of the expression

    - #### getIntegerBounds

          public IntegerValue[] getIntegerBounds()

      For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.
      Returns:
        the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

    - #### getStreamability

          public int getStreamability(int syntacticContext,
                             boolean allowExtensions,
                             List<String> reasons)

      Get the "sweep" of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Parameters:
        `syntacticContext` - one of the values `NAVIGATION_CONTEXT`, `NODE_VALUE_CONTEXT`, `INHERITED_CONTEXT`, `INSPECTION_CONTEXT`
        `allowExtensions` - if false, the definition of "guaranteed streamability" in the W3C specification is used. If true, Saxon extensions are permitted, which make some
        `reasons` - the caller may supply a list, in which case the implementation may add to this list a message explaining why the construct is not streamable, suitable for inclusion in an error message.
      Returns:
        one of the values `W3C_MOTIONLESS`, `W3C_CONSUMING`, `W3C_GROUP_CONSUMING`, `W3C_FREE_RANGING`

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get the immediate sub-expressions of this expression. Default implementation returns a zero-length array, appropriate for an expression that has no sub-expressions.
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### iterateSubExpressionInfo

          public Iterator<SubExpressionInfo> iterateSubExpressionInfo()

      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### setFlattened

          public void setFlattened(boolean flattened)

      Mark an expression as being "flattened". This is a collective term that includes extracting the string value or typed value, or operations such as simple value construction that concatenate text nodes before atomizing. The implication of all of these is that although the expression might return nodes, the identity of the nodes has no significance. This is called during type checking of the parent expression.
      Parameters:
        `flattened` - set to true if the result of the expression is atomized or otherwise turned into an atomic value

    - #### setFiltered

          public void setFiltered(boolean filtered)

      Mark an expression as filtered: that is, it appears as the base expression in a filter expression. This notification currently has no effect except when the expression is a variable reference.
      Parameters:
        `filtered` - if true, marks this expression as the base of a filter expression

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterate

          public SequenceIterator<? extends Item> iterate(XPathContext context)
                                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterateEvents

          public EventIterator iterateEvents(XPathContext context)
                                      throws XPathException

      Deliver the result of the expression as a sequence of events.

      The events (of class `PullEvent`) are either complete items, or one of startElement, endElement, startDocument, or endDocument, known as semi-nodes. The stream of events may also include a nested EventIterator. If a start-end pair exists in the sequence, then the events between this pair represent the content of the document or element. The content sequence will have been processed to the extent that any attribute and namespace nodes in the content sequence will have been merged into the startElement event. Namespace fixup will have been performed: that is, unique prefixes will have been allocated to element and attribute nodes, and all namespaces will be declared by means of a namespace node in the startElement event or in an outer startElement forming part of the sequence. However, duplicate namespaces may appear in the sequence.

      The content of an element or document may include adjacent or zero-length text nodes, atomic values, and nodes represented as nodes rather than broken down into events.

      Parameters:
        `context` - The dynamic evaluation context
      Returns:
        the result of the expression as an iterator over a sequence of PullEvent objects
      Throws:
        `XPathException` - if a dynamic error occurs during expression evaluation

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue(XPathContext context)
                                        throws XPathException

      Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluateAsString

          public CharSequence evaluateAsString(XPathContext context)
                                        throws XPathException

      Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression
        `ClassCastException` - if the result type of the expression is not xs:string?

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the instruction, without returning any tail calls
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates(XPathContext context,
                                    PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails
        `UnsupportedOperationException` - if the expression is not an updating expression

    - #### toString

          public String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form.

      For subclasses of Expression that represent XPath expressions, the result should always be a string that parses as an XPath 3.0 expression. The expression produced should be equivalent to the original making certain assumptions about the static context. In general the expansion will make no assumptions about namespace bindings, except that (a) the prefix "xs" is used to refer to the XML Schema namespace, and (b) the default funcion namespace is assumed to be the "fn" namespace.

      In the case of XSLT instructions and XQuery expressions, the toString() method gives an abstracted view of the syntax that is not designed in general to be parseable.

      Overrides:
        `toString` in class `Object`
      Returns:
        a representation of the expression as a string

    - #### explain

          public abstract void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Parameters:
        `out` - the expression presenter used to display the structure

    - #### explain

          public final void explain(OutputStream out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied outputstream.
      Parameters:
        `out` - the expression presenter used to display the structure

    - #### checkPermittedContents

          public void checkPermittedContents(SchemaType parentType,
                                    StaticContext env,
                                    boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `env` - the static context
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### setContainer

          public void setContainer(Container container)

      Mark an expression as being in a given Container. This link is used primarily for diagnostics: the container links to the location map held in the executable.

      This affects the expression and all its subexpressions. Any subexpressions that are not in the same container are marked with the new container, and this proceeds recursively. However, any subexpression that is already in the correct container is not modified.

      Parameters:
        `container` - The container of this expression.

    - #### getContainer

          public Container getContainer()

      Get the container in which this expression is located. This will usually be a top-level construct such as a function or global variable, and XSLT template, or an XQueryExpression. In the case of free-standing XPath expressions it will be the StaticContext object
      Returns:
        the expression's container

    - #### adoptChildExpression

          public void adoptChildExpression(Expression child)

      Set up a parent-child relationship between this expression and a given child expression.

      Note: many calls on this method are now redundant, but are kept in place for "belt-and-braces" reasons. The rule is that an implementation of simplify(), typeCheck(), or optimize() that returns a value other than "this" is required to set the location information and parent pointer in the new child expression. However, in the past this was often left to the caller, which did it by calling this method, either unconditionally on return from one of these methods, or after testing that the returned object was not the same as the original.
      Parameters:
        `child` - the child expression

    - #### setLocationId

          public void setLocationId(int id)

      Set the location ID on an expression.
      Parameters:
        `id` - the location id

    - #### getLocationId

          public final int getLocationId()

      Get the location ID of the expression
      Returns:
        a location identifier, which can be turned into real location information by reference to a location provider

    - #### getLineNumber

          public int getLineNumber()

      Get the line number of the expression
      Specified by:
        `getLineNumber` in interface `SourceLocator`
      Specified by:
        `getLineNumber` in interface `InstructionInfo`
      Specified by:
        `getLineNumber` in interface `Locator`
      Returns:
        the line number of the expression within the containing module

    - #### getColumnNumber

          public int getColumnNumber()

      Get the column number of the expression
      Specified by:
        `getColumnNumber` in interface `SourceLocator`
      Specified by:
        `getColumnNumber` in interface `Locator`

    - #### getSystemId

          public String getSystemId()

      Get the systemId of the module containing the expression
      Specified by:
        `getSystemId` in interface `SourceLocator`
      Specified by:
        `getSystemId` in interface `InstructionInfo`
      Specified by:
        `getSystemId` in interface `Locator`
      Returns:
        the URI of the containing module

    - #### getPublicId

          public final String getPublicId()

      Get the publicId of the module containing the expression (to satisfy the SourceLocator interface)
      Specified by:
        `getPublicId` in interface `SourceLocator`
      Specified by:
        `getPublicId` in interface `Locator`

    - #### getExecutable

          public Executable getExecutable()

      Get the executable containing this expression
      Returns:
        the containing Executable

    - #### getLocationProvider

          public LocationProvider getLocationProvider()

      Get the LocationProvider allowing location identifiers to be resolved.
      Returns:
        the LocationProvider used to turn the location id into real location information

    - #### doPromotion

          public final Expression doPromotion(Expression subexpression,
                               PromotionOffer offer)
                                       throws XPathException

      Promote a subexpression if possible, and if the expression was changed, carry out housekeeping to reset the static properties and correct the parent pointers in the tree
      Parameters:
        `subexpression` - the subexpression that is a candidate for promotion
        `offer` - details of the promotion being considered @return the result of the promotion. This will be the current expression if no promotion actions have taken place
      Returns:
        the expression that results from doing the promotion as requested. Returns null if and only if the supplied subexpression is null.
      Throws:
        `XPathException` - if an error occurs

    - #### computeStaticProperties

          public final void computeStaticProperties()

      Compute the static properties. This should only be done once for each expression.

    - #### resetLocalStaticProperties

          public void resetLocalStaticProperties()

      Reset the static properties of the expression to -1, so that they have to be recomputed next time they are used.

    - #### computeCardinality

          protected abstract int computeCardinality()

      Compute the static cardinality of this expression
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

    - #### computeSpecialProperties

          protected int computeSpecialProperties()

      Compute the special properties of this expression. These properties are denoted by a bit-significant integer, possible values are in class `StaticProperty`. The "special" properties are properties other than cardinality and dependencies, and most of them relate to properties of node sequences, for example whether the nodes are in document order.
      Returns:
        the special properties, as a bit-significant integer

    - #### computeDependencies

          public int computeDependencies()

      Compute the dependencies of an expression, as the union of the dependencies of its subexpressions. (This is overridden for path expressions and filter expressions, where the dependencies of a subexpression are not all propogated). This method should be called only once, to compute the dependencies; after that, getDependencies should be used.
      Returns:
        the depencies, as a bit-mask

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### checkForUpdatingSubexpressions

          public void checkForUpdatingSubexpressions()
                                              throws XPathException

      Check to ensure that this expression does not contain any inappropriate updating subexpressions. This check is overridden for those expressions that permit updating subexpressions.
      Throws:
        `XPathException` - if the expression has a non-permitted updating subexpression

    - #### isUpdatingExpression

          public boolean isUpdatingExpression()

      Determine whether this is an updating expression as defined in the XQuery update specification
      Returns:
        true if this is an updating expression

    - #### isVacuousExpression

          public boolean isVacuousExpression()

      Determine whether this is a vacuous expression as defined in the XQuery update specification
      Returns:
        true if this expression is vacuous

    - #### copy

          public abstract Expression copy()

      Copy an expression. This makes a deep copy.
      Returns:
        the copy of the original expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### suppressValidation

          public void suppressValidation(int parentValidationMode)

      Suppress validation on contained element constructors, on the grounds that the parent element is already performing validation. The default implementation does nothing.
      Parameters:
        `parentValidationMode` - the kind of validation being performed on the parent expression

    - #### markTailFunctionCalls

          public int markTailFunctionCalls(StructuredQName qName,
                                  int arity)

      Mark tail-recursive calls on stylesheet functions. For most expressions, this does nothing.
      Parameters:
        `qName` - the name of the function
        `arity` - the arity (number of parameters) of the function
      Returns:
        `UserFunctionCall.NOT_TAIL_CALL` if no tail call was found; `UserFunctionCall.FOREIGN_TAIL_CALL` if a tail call on a different function was found;

    - #### toPattern

          public Pattern toPattern(Configuration config,
                          boolean is30)
                            throws XPathException

      Convert this expression to an equivalent XSLT pattern
      Parameters:
        `config` - the Saxon configuration
        `is30` - true if this is XSLT 3.0
      Returns:
        the equivalent pattern
      Throws:
        `XPathException` - if conversion is not possible

    - #### toStreamingPattern

          public Pattern toStreamingPattern(Configuration config,
                                   List<String> reasonForFailure)

      Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
      Parameters:
        `config` - the Saxon configuration
        `reasonForFailure` - a list which will be populated with messages giving reasons why the expression cannot be converted
      Returns:
        the equivalent pattern if conversion succeeds; otherwise null

    - #### getSlotsUsed

          public final int[] getSlotsUsed()

      Get the local variables (identified by their slot numbers) on which this expression depends. Should only be called if the caller has established that there is a dependency on local variables.
      Returns:
        an array of integers giving the slot numbers of the local variables referenced in this expression.

    - #### dynamicError

          protected void dynamicError(String message,
                          String code,
                          XPathContext context)
                               throws XPathException

      Method used in subclasses to signal a dynamic error
      Parameters:
        `message` - the error message
        `code` - the error code
        `context` - the XPath dynamic context
      Throws:
        `XPathException` - always thrown, to signal a dynamic error

    - #### typeError

          protected void typeError(String message,
                       String errorCode,
                       XPathContext context)
                            throws XPathException

      Method used in subclasses to signal a runtime type error
      Parameters:
        `message` - the error message
        `errorCode` - the error code
        `context` - the XPath dynamic context
      Throws:
        `XPathException` - always thrown, to signal a dynamic error

    - #### getConstructType

          public int getConstructType()

      Get the type of this expression for use in tracing and diagnostics
      Specified by:
        `getConstructType` in interface `InstructionInfo`
      Returns:
        the type of expression, as enumerated in class `Location`

    - #### getObjectName

          public StructuredQName getObjectName()

      Description copied from interface: `InstructionInfo`
      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically.
      Specified by:
        `getObjectName` in interface `InstructionInfo`
      Returns:
        the QName of the object declared or manipulated by this instruction or expression

    - #### getProperty

          public Object getProperty(String name)

      Description copied from interface: `InstructionInfo`
      Get the value of a particular property of the instruction. Properties of XSLT instructions are generally known by the name of the stylesheet attribute that defines them.
      Specified by:
        `getProperty` in interface `InstructionInfo`
      Parameters:
        `name` - The name of the required property
      Returns:
        The value of the requested property, or null if the property is not available

    - #### getLineNumber

          public int getLineNumber(long locationId)

      Get the line number within the document or module containing a particular location
      Specified by:
        `getLineNumber` in interface `LocationProvider`
      Parameters:
        `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
      Returns:
        the line number within the document or module.

    - #### getColumnNumber

          public int getColumnNumber(long locationId)

      Description copied from interface: `LocationProvider`
      Get the column number within the document, entity, or module containing a particular location
      Specified by:
        `getColumnNumber` in interface `LocationProvider`
      Parameters:
        `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
      Returns:
        the column number within the document, entity, or module, or -1 if this is not available

    - #### getSystemId

          public String getSystemId(long locationId)

      Get the URI of the document or module containing a particular location
      Specified by:
        `getSystemId` in interface `LocationProvider`
      Parameters:
        `locationId` - identifier of the location in question (as passed down the Receiver pipeline)
      Returns:
        the URI of the document or module.

    - #### getProperties

          public Iterator<String> getProperties()

      Get an iterator over all the properties available. The values returned by the iterator will be of type String, and each string can be supplied as input to the getProperty() method to retrieve the value of the property. The iterator may return properties whose value is null.
      Specified by:
        `getProperties` in interface `InstructionInfo`
      Returns:
        an iterator over the properties.

    - #### getHostLanguage

          public int getHostLanguage()

      Get the host language (XSLT, XQuery, XPath) used to implement the code in this container
      Returns:
        typically `Configuration.XSLT` or `Configuration.XQUERY`

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                            PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

      The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the PathMapNodeSet to which the paths embodied in this expression should be added
      Returns:
        the pathMapNodeSet representing the points in the source document that are both reachable by this expression, and that represent possible results of this expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

    - #### isSubtreeExpression

          public boolean isSubtreeExpression()

      Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
      Returns:
        true if the expression has no dependencies on the context node, or if the only dependencies on the context node are downward selections using the self, child, descendant, attribute, and namespace axes.

    - #### setEvaluationMethod

          public void setEvaluationMethod(int method)

    - #### getEvaluationMethod

          public int getEvaluationMethod()

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()
                                                   throws CannotCompileException

      Return the compiler relating to a particular expression
      Returns:
        the relevant ExpressionCompiler
      Throws:
        `CannotCompileException` - if it is not possible to generate bytecode for this expression

    - #### getStreamingAdjunct

          public StreamingAdjunct getStreamingAdjunct()

      Get a class that supports streamed evaluation of this expression
      Returns:
        the relevant StreamingAdjunct, or null if none is available

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.